
#include	"nrs.h"

#define	SIZE_PACKET	128	// 󑗐MɃobt@̃TCY
#define VISIBLE		1	// FindTable()  VISIBLE ̂݌
#define TABLE_NOCHECK	1	// GetFullPath() Ńe[u𒲂ׂȂ

// '_creat' is obsolete, '_chmod' is obsoletei̊֐ǰx}
#pragma option -w-obs

//----------------------------------------------------------------------------
// class Table
//----------------------------------------------------------------------------

int	Table::UserMaxFile = MAX_FILE;
int	Table::DosAttrib = 0x33;

Table	*Table::PtrTable[ MAX_DRIVE ];
int	Table::Count = 0;


void
Table::SetMaxFile( char *p )
{
	int	i;

	i = atoi( p );

	if( (i > 0) && (i <= MAX_FILE) ){
		UserMaxFile = i;
		printf( " Max File = %d\n", i );
	} else {
		printf( " [ Unknown Max File ] %d\n", i );
	}
}

void
Table::SetDosAttrib( char *p )
{
	int	i;

	sscanf( p, "%x", &i );
	DosAttrib = i & 0xff;

	printf( " Find attribute = %02X\n", (UCHAR) i );
}

void
Table::SetPath( char *newpath )
{
	char	pathname[ SIZE_PATH ];

	strcpy( pathname, newpath );

	// Jg̃Zbg
	setdisk( (Path[0] & 0xdf) - 'A' );
	chdir( Path );

	// hCuύX
	if( (strlen( pathname ) > 1) && (pathname[1] == ':') ){
		setdisk( (pathname[0] & 0xdf) - 'A' );
		if( pathname[2] == 0 ) strcat( pathname, "." );
	}

	// fBNgύX
	if( chdir( pathname ) == -1 ){
		printf( " [ Unknown path ] '%s'\n", pathname );
	} else {
		getcwd( Path , SIZE_PATH );
	}
}

void
Table::SetTable( void )
{
	FFBLK	ffblk;
	int	error;
	char	*fullname;

	fullname = GetFullName( "???????????", TABLE_NOCHECK );

	MaxFile = 0;

	error = findfirst( fullname, &ffblk, DosAttrib );
	while( ( error == 0 ) && ( MaxFile < UserMaxFile ) ){
		FBlock[ MaxFile++ ].SetInfo( &ffblk );

		error = findnext( &ffblk );
	}
}

void
Table::SetTableAll( void )
{
	int	i;

	for( i = 0; i < MAX_DRIVE; i++ ){
		PtrTable[i] -> SetTable();
	}
}

int
Table::FindTable( int number, char *filename, int flag_visible )
{
	char	*p;
	int	i, k;

	for( k = number; k < MaxFile; k++ ){
		if( flag_visible != 0 ){
			if( (FBlock[ k ].GetAttrib() & FA_HIDDEN) != 0 )
				continue;
		}

		p = FBlock[ k ].GetPtrFName();

		for( i = 0; i < 11; i++ ){
			if( filename[i] == '?' ) continue;
			if( filename[i] != p[i] ) break;
		}
		if( i == 11 ) return k;
	}

	return -1;
}

int
Table::FindTable2( int number, char *filename, int flag_visible )
{
	char	*p;
	int	i, k;

	if( number >= MaxFile ) return -1;

	for( k = number; k >= 0; k-- ){
		if( flag_visible != 0 ){
			if( (FBlock[ k ].GetAttrib() & FA_HIDDEN) != 0 )
				continue;
		}

		p = FBlock[ k ].GetPtrFName();

		for( i = 0; i < 11; i++ ){
			if( filename[i] == '?' ) continue;
			if( filename[i] != p[i] ) break;
		}
		if( i == 11 ) return k;
	}

	return -1;
}

char *
Table::GetFullName( char *filename, int flag_table )
{
	static char	workPath[ SIZE_PATH + 12 ];
	static char	workPath2[ SIZE_PATH + 12 ];

	char	*p, *p0;
	char	c;
	int	i;

	if( flag_table == 0 ){
		// ۂɂ݂͑ĂA|PR猩ȂΑΏۊO
		if( FindTable( 0, filename ) == -1 ) return 0;

		p0 = workPath;
	} else {
		p0 = workPath2;
	}

	strcpy( p0, Path );
	i = strlen( p0 ); p = &p0[i];

	// [gȊO
#ifndef UNIX
	if( i != 3 ) *p++ = '\\';
#else
	if( i != 3 ) *p++ = '/';
#endif

	for( i = 0; i < 8; i++ ){
		c = filename[i];
		if( c == ' ' ) break;
		*p++ = c;
	}
	*p++ = '.';

	for( i = 0; i < 3; i++ ){
		c = filename[ 8 + i ];
		if( c == ' ' ) break;
		*p++ = c;
	}
	*p = 0;

	return p0;
}

int
Table::CmdCreate( int reg_a, HANDLE *pH )
{
	FFBLK	ffblk;
	char	*fullname;

	int	i;

	fullname = GetFullName( pH -> PFileName, TABLE_NOCHECK );
	printf( "\n [ Create ] '%s'\n", fullname );

	// |PR猩ȂĂAp\Rɑ݂邩ȂB
	// ̓G[ƂB
	if( FindTable( 0, pH -> PFileName ) == -1 ){
		if( findfirst( fullname, &ffblk, 0x3f ) == 0 ){
			printf(
				"\n Ӂ '%s'\n"
				"@|PR͌܂񂪁A"
				"ۂɂ݂͑Ă܂B\n"
				"@ create ܂B\n", fullname
			);
			return -1;
		}
	}

	if( (i = _creat( fullname, reg_a )) == -1 ) return -1;

	pH -> DHandle = i;
	pH -> PDrive = NumberDrive;
	pH -> POpenMode = 3; // ǂݏ

	Com::Putc( CMD_CREATE );
	return 0;
}

int
Table::CmdOpen( int reg_a, HANDLE *pH )
{
	char	*fullname;
	int	mode;

	int	i;

	if( (fullname = GetFullName( pH -> PFileName )) == 0 ) return -1;
	printf( "\n [ Open ] '%s'\n", fullname );

	reg_a &= 3;	// ꉞʂQrbĝ݌
	switch( reg_a ){
		case 0x01: mode = O_RDONLY; break;
		case 0x02: mode = O_WRONLY; break;
		case 0x03: mode = O_RDWR; break;
		default: return -1;
	}

	if( (i = open( fullname, mode | O_BINARY )) == -1 )
		return -1;

	pH -> DHandle = i;
	pH -> PDrive = NumberDrive;
	pH -> POpenMode = reg_a;

	Com::Putc( CMD_OPEN );
	return 0;
}

int
Table::CmdClose( HANDLE *pH )
{
	Com::Putc( CMD_CLOSE );

	if( close( pH -> DHandle ) != 0 ) return -1;
	pH -> DHandle = -1;

	SetTableAll();
	Com::Putc( CMD_CLOSE );

	return 0;
}

int
Table::CmdRead( int handle, int command )
{
	UINT	packs;
	UINT	check_sum;
	long	bytes;

	char	buffer[ SIZE_PACKET ];
	int	i;

	Com::Putc( command );

	Com::Getc();	// reg_a;
	bytes = Com::Getp();

	while( bytes > 0 ){
		if( bytes > SIZE_PACKET )
			packs = SIZE_PACKET;
		else
			packs = bytes;

		i = read( handle, buffer, packs );
		if( i == -1 ) return -1;
		if( i == 0 ) break;

		packs = i;
		Com::Putc( packs );

		check_sum = 0;
		for( i = 0; i < packs; i++ ){
			Com::Putc( buffer[i] );
			check_sum += buffer[i];
		}
		Com::Putc( check_sum );

		switch( Com::Getc() )
		{
		case 0x20:
			if( Com::PtrCom -> GetMsgOff() == FALSE ){
				putchar( '.' );
			}
			break;

		case 0x21:
			if( Com::PtrCom -> GetMsgOff() == FALSE ){
				putchar( 'x' );
			}
		default:
			return -1;
		}

		bytes -= packs;
	}

	Com::Putc( 0x00 );
	return 0;
}

int
Table::CmdWrite( int handle )
{
	UINT	packs;
	UCHAR	check_sum;

	char	buffer[ SIZE_PACKET * 2 ];
	int	i;

	Com::Putc( CMD_WRITE );

	for( ; ; ){
		// ڂƂȂ̂ŐɎM
		if( (packs = Com::Getc()) >= 0xf0 ) return -1;
		for( i = 0; i < packs; i++ ) buffer[i] = Com::Getc();
		check_sum = Com::Getc();

		if( packs == 0 ) break;

		for( i = 0; i < packs; i++ ) check_sum -= buffer[i];
		if( check_sum != 0 ){
			if( Com::PtrCom -> GetMsgOff() == FALSE )
				putchar( 'x' );
			Com::Putc( 0x21 );
			continue;
		}

		i = write( handle, buffer, packs );
		if( (i == -1) || (i != packs) ) return -1;

		if( Com::PtrCom -> GetMsgOff() == FALSE )
			putchar( '.' );
		Com::Putc( 0x20 );
	}

	return 0;
}

int
Table::CmdGetc( int handle, int command )
{
	char	buffer[1];
	int	i;

	Com::Putc( command );

	if( (i = read( handle, buffer, 1 )) == -1 ){
		Com::Putc( 0 );
		return -1;
	}

	if( command == CMD_GETC2 ) lseek( handle, -1, SEEK_CUR );

	Com::Putc( i );
	Com::Putc( buffer[0] );

	return 0;
}

int
Table::CmdPutc( int handle )
{
	char	buffer[1];
	int	i;

	Com::Putc( CMD_PUTC );

	buffer[0] = Com::Getc();

	if( (i = write( handle, buffer, 1 )) == -1 ) return -1;

	Com::Putc( i );
	return 0;
}

int
Table::CmdSeek( int handle )
{
	int	reg_a;
	long	bytes;

	Com::Putc( CMD_SEEK );

	reg_a = Com::Getc();
	bytes = Com::Getp();

	switch( reg_a )
	{
	case 0x00:	// SEEK_SET
		break;

	case 0x01:	// SEEK_CUR
		if( (bytes & 0x800000L) != 0 ) bytes |= 0xff000000L;
		break;

	case 0x02:	// SEEK_END
		bytes = -bytes;
		break;

	default:
		return -1;
	}

	if( (bytes = lseek( handle, bytes, reg_a )) == -1 ) return -1;

	Com::Putc( CMD_SEEK );
	Com::Putp( bytes );
	return 0;
}

int
Table::CmdInfo( HANDLE *pH )
{
	int	reg_a;
	int	number;
	long	filesize, fileptr;

	char	*p;
	int	i;

	Com::Putc( CMD_INFO );

	reg_a = Com::Getc();
	switch( reg_a )
	{
	case 0:
		fileptr = tell( pH -> DHandle );
		filesize = filelength( pH -> DHandle );

		if( (fileptr == -1) || (filesize == -1) ) break;

		Com::Putc( CMD_INFO );
		Com::Putc( pH -> POpenMode );
		Com::Putp( fileptr );
		Com::Putp( filesize );

		return 0;

	case 1:
		if( (number = FindTable( 0, pH -> PFileName )) == -1 )
			break;

		p = FBlock[ number ].GetPtrFName();

		Com::Putc( CMD_INFO );
		for( i = 0 ; i < 11; i++ ) Com::Putc( p[i] );
		Com::Putc( FBlock[ number ].GetAttrib() );

		return 0;
	}

	return -1;
}

int
Table::CmdAttrib( void )
{
	int	reg_a;
	char	filename[11];

	int	i;

	Com::Putc( CMD_ATTRIB );

	reg_a = Com::Getc();
	for( i = 0; i < 11; i++ ) filename[i] = Com::Getc();

	switch( reg_a )
	{
	case 0:
		FileInfo	*pF;
		int		number;

		if( (number = FindTable( 0, filename )) == -1 ) break;

		pF = &FBlock[ number ];
		Com::Putc( CMD_ATTRIB );
		Com::Putc( pF -> GetAttrib() );
		Com::Putw( pF -> GetTime() );
		Com::Putw( pF -> GetDate() );
		Com::Putp( pF -> GetSize() );

		return 0;

	case 1:
		REGS	regs;

		char	*fullname;
		int	handle;

		int	f_attrib = Com::Getc();
		int	f_time = Com::Getw();
		int	f_date = Com::Getw();

		if( (fullname = GetFullName( filename )) == 0 ) return -1;

		if( (f_time != 0) || (f_date != 0) ){	// ݒ͂͂˂

			// tE
			if( (handle = open( fullname, O_RDONLY )) == -1 )
				break;

			regs.x.ax = 0x5701;	// t@C̓tE̐ݒ
			regs.x.bx = handle;
			regs.x.cx = f_time;
			regs.x.dx = f_date;
			intdos( &regs, &regs );
// ̕悢ȂA傫̂ŃpX
//		FTIME	ftime;
//		ftime.ft_tsec = f_time & 0x1f;
//		ftime.ft_min = (f_time >> 5) & 0x3f;
//		ftime.ft_hour = (f_time >> 11) & 0x1f;
//		ftime.ft_day = f_date & 0x1f;
//		ftime.ft_month = (f_date >> 5) & 0x0f;
//		ftime.ft_year = (f_date >> 9) & 0x1ff;
//		if( setftime( handle, &ftime ) == -1) break;

			close( handle );
		}

		// 
		if( _chmod( fullname, 1, f_attrib ) == -1 ) break;

		SetTableAll();
		Com::Putc( CMD_ATTRIB );
		return 0;
	}

	return -1;
}

int
Table::CmdFiles( void )
{
	int	reg_a;
	int	reg_bx;
	char	filename[11];
	int	flag_visible = 0;

	char	*p;
	int	i;

	Com::Putc( CMD_FILES );

	reg_a = Com::Getc();
	reg_bx = Com::Getw();
	for( i = 0; i < 11; i++ ) filename[i] = Com::Getc();

	switch( reg_a )
	{
	case 0x00:
		flag_visible = VISIBLE;
	case 0x80:
		reg_bx = FindTable( reg_bx, filename, flag_visible );
		break;

	case 0x01:
		flag_visible = VISIBLE;
	case 0x81:
		reg_bx = FindTable2( reg_bx, filename, flag_visible );
		break;

	default:
		return -1;
	}

	if( reg_bx == -1 ) goto not_found;

	Com::Putc( CMD_FILES );
	Com::Putw( reg_bx );

	p = FBlock[ reg_bx ].GetPtrFName();
	for( i = 0; i < 11; i++ ) Com::Putc( p[i] );

	return 0;

not_found:
	if( Com::PtrCom -> GetMsgOff() == FALSE ) putchar( '*' );
	Com::Putc( 2 );	// łQȂ́H :-(

	return 0;
}

int
Table::CmdRename( void )
{
	char	filename[11], filename2[11];
	char	*fullname, *fullname2;

	int	i;

	Com::Putc( CMD_RENAME );

	for( i = 0; i < 11; i++ ) filename[i] = Com::Getc();
	for( i = 0; i < 11; i++ ) filename2[i] = Com::Getc();

	if( (fullname = GetFullName( filename )) == 0 ) return -1;
	fullname2 = GetFullName( filename2, TABLE_NOCHECK );

	if( rename( fullname, fullname2 ) != 0 ) return -1;

	SetTableAll();
	Com::Putc( CMD_RENAME );

	return 0;
}

int
Table::CmdDelete( void )
{
	char	filename[11];
	char	*fullname;

	int	i;

	Com::Putc( CMD_DELETE );

	for( i = 0; i < 11; i++ ) filename[i] = Com::Getc();

	if( (fullname = GetFullName( filename )) == 0 ) return -1;
	if( remove( fullname ) != 0 ) return -1;

	SetTableAll();
	Com::Putc( CMD_DELETE );

	return 0;
}

int
Table::CmdDiskFree( void )
{
	REGS	regs;
	ULONG	clusters, sectors, bytes;

	Com::Putc( CMD_DISKFREE );

	regs.h.ah = 0x36;	// fBXÑt[Xy[X̎擾
	regs.h.dl = Path[0] - 'A' + 1;
	intdos( &regs, &regs );

	clusters = (ULONG) regs.x.bx;
	sectors = (ULONG) regs.x.cx;
	bytes = (ULONG) regs.x.ax;

	Com::Putc( CMD_DISKFREE );
	Com::Putp( bytes * sectors * clusters );

	return 0;
}

int
Table::CmdInit( void )
{
	char	pathname[ SIZE_PATH ];

	UCHAR	c;
	int	i;

	printf( "\n" );
	Com::Putc( CMD_INIT );

	for( i = 0; i < SIZE_PATH -1; i++ ){
		c = Com::Getc();
		if( (c <= '!') || (c == 0xff) ) break;
		pathname[i] = c;
	}
	pathname[i] = 0;

	// pXȂfBNgړ
	if( pathname[0] != 0 ) SetPath( pathname );

	SetTable();

	// ύX̃fBNg\
	for( i = 0; i < MAX_DRIVE; i++ ){
		printf( " %c|%s\n", i + 'A', PtrTable[i] -> GetPath() );
	}

	Com::Putc( CMD_INIT );
	return 0;
}

