/*  MS-DOS L̊֐Q  */
#include  <stdio.h>
#include  <stdlib.h>
#include  <fcntl.h>
#include  <sys/types.h>
#include  <dirent.h>
#include  <string.h>

#ifdef FBSD
#include  <sys/param.h>
#include  <sys/mount.h>
#endif
#ifdef LINUX
#include  <sys/vfs.h>
#endif


#include  <sys/stat.h>
#include  <stdarg.h>
#include  "dos.h"
#include  "dir.h"
#include  "getchkbh.h"


#define  MAX_DIR_LEN  1024
#define  MAX_HANDLE_FILE 16

int chk_dir(char *filename);
int get_filetime(char *fullpathname, 
				 unsigned int *dateword, unsigned int *timeword);
int set_filetime(char *fullpathname,
				 unsigned int dateword, unsigned int timeword);


static DIR *dirp;
static struct dirent *direntp;
static char dirname[MAX_DIR_LEN];
static char findfilename[MAX_DIR_LEN];
static int find_attrib;
static char *creatfile[MAX_HANDLE_FILE];


int ioctl(int handle, int nazo ,...)
{
	if( (handle == 0) && (nazo == 0x06)){  /*  L[ꂽǂ  */
		return kbhit();                    /*  `FbN炵B          */
	}                                      /*  ĂȂA0 */
	                                       /*  ԂB                    */

	else{                                  /*  ȊO͂ȂɂȂB  */
		return -1;
	}
}


int _creat(const char *path, int attribute)
{
	int fh;
	FILE *fp;
	mode_t attribmode;


	attribmode = 0;
	if((attribute & FA_RDONLY) != 0){
		attribmode = (S_IRUSR | S_IXUSR) | \
		             (S_IRGRP | S_IXGRP) | \
					 (S_IROTH | S_IXOTH) ;
	}
	else{
		attribmode |= (S_IRUSR | S_IWUSR | S_IXUSR) | \
		              (S_IRGRP | S_IXGRP) | \
					  (S_IROTH | S_IXOTH);
	}
	
	fh = open(path, O_RDWR | O_CREAT | O_TRUNC, attribmode);

/*  ^CX^vݒ莞̂߂ fh  path ̑Ήێ  */
	if(fh != -1){
		if(creatfile[fh] != NULL){
			free(creatfile[fh]);
		}
		
		creatfile[fh] = (char *)malloc(sizeof(char) * (strlen(path) + 1));
		if(creatfile[fh] != NULL){
			strcpy(creatfile[fh], path);
		}
		else{
			fprintf(stderr, "malloc error in function _creat\n");
		}
	}

#if 0
	close(fh);  /*  tbV̂  */
	fh = open(path, O_RDWR | O_CREAT | O_TRUNC, 0);
#endif

#if 0
	if((fp = fdopen(fh, "r+b")) == NULL){
		fprintf(stderr, "Error in NOIKE's function _creat\n");
		getch();
	}
	else{
		fflush(fp);
	}
#endif

	return fh;
}


int setdisk(int drive)
{
/*  Ƃ肠A1 ԂĂ݂  */
	return 1;
}


int intdos(union REGS *inregs, union REGS *outregs)
{
	char           drive_path[MAX_DIR_LEN];
	struct statfs  statbuf;


	if(inregs->h.ah == 0x36){  /*  fBXN̋󂫗eʂ̎擾  */
		/*  inregs->h.dl == 1 -> A drive
			             == 2 -> B drive
						 ...
						 == 26-> Z drive  */
		/*  傤Ȃϐ HOME ̋󂫗eʂԂ  */
		strcpy(drive_path, getenv("HOME"));
		statfs(drive_path, &statbuf);
		outregs->x.bx = statbuf.f_bavail;  /*  as MS-DOS clustars  */
		outregs->x.cx = statbuf.f_bsize;   /*  as MS-DOS sectors   */
		outregs->x.ax = 1;                 /*  as MS-DOS bytes     */
		/*                      zg͈Ⴄ񂾂낤(^^;)       */

		return 0;
	}
	else if(inregs->x.ax  == 0x5701){
		set_filetime(creatfile[inregs->x.bx], inregs->x.dx, inregs->x.cx);
		return 0;
	}

/*  ȊÓAƂ肠A-1 ԂĂ݂  */
	return -1;
}


int findfirst(const char *pathname, struct ffblk *ffblk, int attrib)
{
	int i, j;
	char filename[MAX_DIR_LEN];
	FILE *fp;
	struct stat statbuf;


	strcpy(dirname, pathname);
	for(i = strlen(dirname); i != 0; i--){
		if(*(dirname + i) == '/'){
			*(dirname + i) = '\0';

			i += 1;
			j = 0;
			do{
				findfilename[j] = *(dirname + i);
				i++;
				j++;
			}while(*(dirname + i) != '\0');
			break;
		}
	}

	find_attrib = attrib;
	
	dirp = opendir(dirname);
	if(dirp == NULL){
		fprintf(stderr, "In findfirst: Can't open dir \"%s\"", dirname);
		return -1;
	}

	rewinddir(dirp);


	while(1){
		direntp = readdir(dirp);
		if(direntp == NULL){
			closedir(dirp);
			return -1;
		}
		else{
			if(strcmp(findfilename, "????????.???") == 0){
				strcpy(filename, dirname);
				strcat(filename, "/");
				strcat(filename, direntp->d_name);
				
				lstat(filename, &statbuf);
				
				if((find_attrib & FA_DIREC) != 0){
					if((statbuf.st_mode & S_IFDIR) != 0){
						break;

					}
				}

				if((find_attrib & FA_RDONLY) != 0){
					if((statbuf.st_mode & S_IWUSR) == 0){
						break;
					}
				}
				else{
					if((statbuf.st_mode & S_IWUSR) == 0){
						continue;
					}
				}

				if((find_attrib & FA_ARCH) != 0){
					if((statbuf.st_mode & S_IFDIR) == 0){
						break;
					}
				}
			}
		}
	}
	
	strcpy(ffblk->ff_name, direntp->d_name);

	if((statbuf.st_mode & (S_IFDIR)) == 0){
		/*  t@C  */
		ffblk->ff_attrib = FA_ARCH;
		
		/*  t@CTCY̎擾  */  
		fp = fopen(filename, "rb");
		if(fp == NULL){
			ffblk->ff_fsize = 0;
		}
		else{
			fseek(fp, 0, SEEK_END);
			ffblk->ff_fsize = ftell(fp);
			fclose(fp);
		}
	}
	else{
		/*  fBNg  */
		ffblk->ff_attrib = FA_DIREC;
		ffblk->ff_fsize = 0;  /*  fBNg̃t@CTCY 0  */
	}

	/*  Read only t@Cɂ́Ȃt  */
	if((statbuf.st_mode & S_IWUSR) == 0){
		ffblk->ff_attrib |= FA_RDONLY;
	}


/*  ^CX^v̎擾  */
	get_filetime(filename, &(ffblk->ff_fdate), &(ffblk->ff_ftime));

	return 0;
}


int findnext(struct ffblk *ffblk)
{
	char filename[MAX_DIR_LEN];
	FILE *fp;
	struct stat statbuf;


	while(1){
		direntp = readdir(dirp);
		if(direntp == NULL){
			closedir(dirp);
			return -1;
		}
		else{
			if(strcmp(findfilename, "????????.???") == 0){
				strcpy(filename, dirname);
				strcat(filename, "/");
				strcat(filename, direntp->d_name);
				
				lstat(filename, &statbuf);
				
				if((find_attrib & FA_DIREC) != 0){
					if((statbuf.st_mode & S_IFDIR) != 0){
						break;

					}
				}

				if((find_attrib & FA_RDONLY) != 0){
					if((statbuf.st_mode & S_IWUSR) == 0){
						break;
					}
				}
				else{
					if((statbuf.st_mode & S_IWUSR) == 0){
						continue;
					}
				}

				if((find_attrib & FA_ARCH) != 0){
					if((statbuf.st_mode & S_IFDIR) == 0){
						break;
					}
				}
			}
		}
	}
	
	
	strcpy(ffblk->ff_name, direntp->d_name);
	
	if((statbuf.st_mode & (S_IFDIR)) == 0){
		/*  t@C  */
		ffblk->ff_attrib = FA_ARCH;

		/*  t@CTCY̎擾  */
		fp = fopen(filename, "rb");
		if(fp == NULL){
			ffblk->ff_fsize = 0;
		}
		else{
			fseek(fp, 0, SEEK_END);
			ffblk->ff_fsize = ftell(fp);
			fclose(fp);
		}
	}
	else{
		/*  fBNg  */
		ffblk->ff_attrib = FA_DIREC;
		ffblk->ff_fsize = 0;  /*  fBNg̃t@CTCY 0  */
	}

	if((statbuf.st_mode & S_IWUSR) == 0){
		ffblk->ff_attrib |= FA_RDONLY;
	}



/*  ^CX^v̎擾  */
	get_filetime(filename, &(ffblk->ff_fdate), &(ffblk->ff_ftime));

	return 0;
}


long tell(int handle)
{
	FILE *fp;
	long retval;

	
	if((fp = fdopen(handle, "rb")) == NULL){
		fprintf(stderr, "Error in NOIKE's function tell().\n");
		return -1;
	}

	retval = ftell(fp);

	return retval;
}


long filelength(int handle)
{
	FILE *fp;
	long length;
	long org_loc;

	
	if((fp = fdopen(handle, "rb")) == NULL){
		fprintf(stderr, "Error in NOIKE's function filelength().\n");
		return -1;
	}

	org_loc = ftell(fp);
	fseek(fp, 0, SEEK_END);
	length = ftell(fp);
	fseek(fp, org_loc, SEEK_SET);


	return length;
}


int _chmod(const char *pathname, int func, ... )
{
    va_list argptr;
	int attrib;
	mode_t attribmode;
	struct stat statbuf;

	
	if(func == 0){
		lstat(pathname, &statbuf);
		if((statbuf.st_mode & S_IWUSR) == 0){
			return (FA_RDONLY | FA_ARCH);
		}
	}
	else{
		va_start(argptr, func);
		attrib = va_arg(argptr, int);
		va_end(argptr);

		attribmode = 0;
		if((attrib & FA_RDONLY) != 0){
			attribmode = (S_IRUSR | S_IXUSR) | \
			             (S_IRGRP | S_IXGRP) | \
						 (S_IROTH | S_IXOTH);
			if(chmod(pathname, attribmode) == -1){
				fprintf(stderr, "Error in NOIKE's function _chmod().\n");
			}
		}
		return 0;
	}
	return -1;
}
